<script setup lang="ts">
    import { ref, onMounted, computed, watch } from "vue";
    import { triggerLogout, triggerRequestToken, getBearer } from "./../functions/bearer-auth";
    import { success } from "./../plugins/toast";
    import useAuthStore from "./../stores/auth";
    import { pushToClipboard } from "./../functions/clipboard";
    import { openBrowser, openGraphql } from "./../functions/open";
    import useNavigationStore from "./../stores/navigation";
    import { useRouter } from "vue-router";
    import APIVersionStatus from "./APIVersionStatus.vue";
    import { addServiceWorkerListener } from "../plugins/serviceWorker";
    import { baseURL } from "../functions/env";
    import { DynamicRoutePaths } from "../plugins/router";

    const dev = process.env.DEV;

    const router = useRouter();
    const authStore = useAuthStore();
    const navigationStore = useNavigationStore();
    const hash = ref("");
    const token = ref("");
    const requestURL = ref("");
    const headers = computed(() => {
        return `{\"Authorization\": \"Bearer ${authStore.token}\"}`;
    });

    async function requestToken() {
        triggerRequestToken();
        success("Requested Token, look into Browser");
    }

    async function logout() {
        triggerLogout();
        authStore.updateAuth();
        success("Logged out");
    }

    onMounted(async () => {
        token.value = await getBearer();

        addServiceWorkerListener("show-hash", (payload: { hash: string; requestURL: string }) => {
            hash.value = payload.hash;
            requestURL.value = payload.requestURL;
        });

        addServiceWorkerListener("new-bearer-token", async (_payload: any) => {
            token.value = await getBearer();
        });

        authStore.updateAuth();
    });

    watch(token, async () => {
        if (token.value != "EMPTYREPLACEMENTTOKEN" && token.value != "") {
            const authenticated = await authStore.updateAuth();
            if (authenticated) {
                success("Login Token received");
            }
            requestURL.value = "";
            hash.value = "";
        }
    });

    function openOwnProfile() {
        if (authStore.ownInstructorUuid) {
            navigationStore.instructorId = authStore.ownInstructorUuid;
            router.push({ name: DynamicRoutePaths.InstructorDetails }); // TODO move this out possibly
        }
    }
</script>

<template>
    <div class="pa-3">
        <h2 class="text-center">Authentication</h2>

        <div class="my-2 text-center">
            <v-btn v-if="!authStore.authenticated" @click="requestToken">
                <template v-slot:prepend> <span class="material-symbols-outlined"> login </span></template>
                Login
            </v-btn>
            <v-btn v-else @click="logout">
                <template v-slot:prepend> <span class="material-symbols-outlined"> logout </span></template>
                Logout
            </v-btn>
        </div>

        <v-card v-if="hash != '' && !authStore.authenticated" variant="tonal" class="my-2">
            <template v-slot:text>
                <p>Compare Hash: {{ hash }}</p>
            </template>
        </v-card>

        <v-card v-if="requestURL != '' && !authStore.authenticated" variant="tonal" class="my-2">
            <template v-slot:text>
                <p>Manual Login Redirection: <a :href="requestURL" target="_blank">CLICK HERE</a></p>
            </template>
        </v-card>

        <v-card v-if="authStore.user != undefined" title="Benutzer" variant="tonal" class="my-2">
            <template v-slot:text>
                <p><b>Username:</b> {{ authStore.user.preferred_username }}</p>
                <p><b>Name:</b> {{ authStore.user.name }}</p>
                <p><b>Zugewiesene Rollen:</b></p>
                <div>
                    <ul style="width: 70%; margin: auto">
                        <li v-if="authStore.hasRoleString('readparticipant')">
                            <v-row align="center" style="margin-left: 0.5em">
                                Alle Teilnehmer Daten Lesen
                                <v-checkbox-btn style="opacity: 0"></v-checkbox-btn>
                            </v-row>
                        </li>
                        <li v-if="authStore.hasRoleString('readinstructor')">
                            <v-row align="center" style="margin-left: 0.5em">
                                Alle Zirkelleiter Daten Lesen
                                <v-checkbox-btn style="opacity: 0"></v-checkbox-btn>
                            </v-row>
                        </li>
                        <li v-if="authStore.hasRoleString('writeparticipant')">
                            <v-row align="center" style="margin-left: 0.5em">
                                Teilnehmer Daten Schreiben
                                <v-checkbox-btn v-model="authStore.hasNotForfeitWriteParticipant"></v-checkbox-btn>
                            </v-row>
                        </li>
                        <li v-if="authStore.hasRoleString('writeinstructor')">
                            <v-row align="center" style="margin-left: 0.5em">
                                Zirkelleiter Daten Schreiben
                                <v-checkbox-btn v-model="authStore.hasNotForfeitWriteInstructor"></v-checkbox-btn>
                            </v-row>
                        </li>
                        <li v-if="authStore.hasRoleString('export')">
                            <v-row align="center" style="margin-left: 0.5em">
                                Exports Verwalten
                                <v-checkbox-btn v-model="authStore.hasNotForfeitExport"></v-checkbox-btn>
                            </v-row>
                        </li>
                        <li v-if="authStore.hasRoleString('managesignup')">
                            <v-row align="center" style="margin-left: 0.5em">
                                Teilnehmer Registrierung Verwalten
                                <v-checkbox-btn v-model="authStore.hasNotForfeitManageSignup"></v-checkbox-btn>
                            </v-row>
                        </li>
                        <li v-if="authStore.hasRoleString('managezirkelplan')">
                            <v-row align="center" style="margin-left: 0.5em">
                                Zirkelplan Verwalten
                                <v-checkbox-btn v-model="authStore.hasNotForfeitManageZirkelPlan"></v-checkbox-btn>
                            </v-row>
                        </li>
                        <li v-if="authStore.hasRoleString('writeevents')">
                            <v-row align="center" style="margin-left: 0.5em">
                                Events Verwalten
                                <v-checkbox-btn v-model="authStore.hasNotForfeitWriteEvents"></v-checkbox-btn>
                            </v-row>
                        </li>
                        <li v-if="authStore.hasRoleString('deleterecords')">
                            <v-row align="center" style="margin-left: 0.5em">
                                Einträge Löschen
                                <v-checkbox-btn v-model="authStore.hasNotForfeitDeleteRecords"></v-checkbox-btn>
                            </v-row>
                        </li>
                        <li>
                            <v-row align="center" style="margin-left: 0.5em">
                                Fraktivitäten Verteilen
                                <v-checkbox-btn v-model="authStore.hasNotForfeitDistributeFractivities"></v-checkbox-btn>
                            </v-row>
                        </li>
                    </ul>
                </div>

                <v-row class="justify-center mt-5" v-if="authStore.ownInstructorUuid != null">
                    <p class="v-col-md-7">
                        <v-btn @click="openOwnProfile" style="width: 100%">
                            <template v-slot:prepend> <span class="material-symbols-outlined"> school </span></template>
                            Eigenes Zirkelleiter Profil
                        </v-btn>
                    </p>
                    <p class="v-col-md-7">
                        <v-btn @click="openBrowser(baseURL() + 'account')" style="width: 100%">
                            <template v-slot:prepend> <span class="material-symbols-outlined"> edit </span></template>
                            Stammdaten bearbeiten
                        </v-btn>
                    </p>
                </v-row>

                <v-expansion-panels class="mt-10" v-if="authStore.hasSomeAdvancedAdminRights || dev">
                    <v-expansion-panel title="Fortgeschrittene Admin Optionen">
                        <template v-slot:text>
                            <p class="text-red">!! Zugriff auf die Backend-API Funktionen sind nur für geschultes Personal !!</p>
                            <p>
                                Nur wenn die notwendigen Rollen in "Zugewiesene Rollen" angezeigt werden, werden fortgeschrittene
                                Operationen funktionieren.
                            </p>
                            <p>
                                Zugriff funktioniert nur, wenn die "header" korrekt gesetzt sind, da die API zugriffs-geschützt
                                ist.
                            </p>
                            <p>
                                Kopiere die folgende Konfiguration und füge sie in den <b>HTTP HEADERS</b> Bereich auf der
                                Webseite ein.
                            </p>
                            <p class="text-red">
                                !! Die Konfiguration enthält einen geheimen TOKEN, der nicht geleaked werden darf, da er Zugriff
                                auf dem Access-Level des aktuellen Benutzers ermöglicht !!
                            </p>
                            <v-textarea :readonly="true" label="HTTP HEADERS" v-model="headers">
                                <template v-slot:append
                                    ><span
                                        class="material-symbols-outlined pointer"
                                        @click="pushToClipboard(headers, 'Header kopiert!')"
                                    >
                                        content_copy
                                    </span>
                                </template>
                            </v-textarea>
                            <div class="text-center">
                                <v-btn @click="openGraphql">
                                    <template v-slot:prepend> <span class="material-symbols-outlined"> api </span></template>
                                    API
                                </v-btn>
                            </div>
                        </template>
                    </v-expansion-panel>
                </v-expansion-panels>
            </template>
        </v-card>

        <div class="mt-5 text-center" v-if="authStore.authenticated">
            <v-btn @click="logout">
                <template v-slot:prepend> <span class="material-symbols-outlined"> logout </span></template>
                Logout
            </v-btn>
        </div>

        <APIVersionStatus />
    </div>
</template>
